$(document).ready(function () {
    $("body").off('click').on("click", '.remove', remove);
//    $(".tbody").on("blur", '.rate', autoAddRows);
    $("body").on("change blur", '.qty, .rate, .amount, .discperc, .total', itemCal);
    $("body").on("change blur", '.subtotal, .litemdisc, .cdicsperc, .cdiscamt, .lessoth, .vatperc, .vatamt, .packing, .netamt', mainbCal);
    $("body").on("keyup focus blur", '.total', autoAddRows);
    $("body").on("keyup focus blur change", '.itemcode', GetItemFromCode);
    $("body").on("keyup focus blur change", '.item', showDetail);


    $("body").on("click change blur", ".oms, .gstperc", gethsn);
    $("body").on("click change blur", ".oms, .gstperc", getGSTPerc);
    $("body").on("change", ".purvouch", getPurchase);

    function getPurchase() {
        var purvouch = $(".purvouch").val();
        $.post('get_purchase_data.php', {purvouch: purvouch}, function (data) {
            $("#debdtltab").html(data);
            mainbCal();
        });

    }


    function getGSTPerc() {
        var gstperc = $(".gstperc").val();
//                getdcPerc = 0;

        $.post('getGSTPerc.php', {gstperc: gstperc}, function (data) {

            var mgstperc = data.gstperc,
                    mgst = mgstperc / 2;

            if ($(".oms").prop('checked')) {
                $('.igstperc').val(mgstperc);
                $('.cgstperc').val(0);
                $('.sgstperc').val(0);

            } else {
                $('.cgstperc').val(mgst);
                $('.sgstperc').val(mgst);
                $('.igstperc').val(0);
            }

        }, 'json');
        mainbCal();
    }

    function gethsn() {
//        var tr = $(this).closest("tr");
        var gstperc = $('.gstperc').val(),
                mgst = gstperc / 2;
//        $.post('gethsncode.php', {item: item}, function (data) {
//            tr.find('.hsncode').val(data.hsn);

//        if ($(".oms").prop('checked')) {
//            $('.igstperc').val(gstperc);
//            $('.cgstperc').val(0);
//            $('.sgstperc').val(0);
//
//        } else {
//            $('.cgstperc').val(mgst);
//            $('.sgstperc').val(mgst);
//            $('.igstperc').val(0);
//        }
        mainbCal();
        getGSTPerc();
//        }, 'json');
    }

    function GetItemFromCode() {
        var $row = $(this).closest("tr");
        var itemcode = $row.find(".itemcode").val();
        $.post('show_item_dtl.php', {itemcode: itemcode}, function (data) {
            if (data != '') {
                $row.find(".item").html(data).trigger("change");
            }
        });
    }

    //getting rate from item
    function showDetail() {
        var tr = $(this).closest("tr");
        var name = tr.find('.item').val();
        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "get_itemrate_dtl.php",
            data: "name=" + name + "",
            success: function (response) {
                var code = response.code;
                var rate = response.rate;
                var msp = response.msp;
                var mrp = response.mrp;
                var unit = response.unit;
                $(tr.find('.itemcode')).val(code);
                $(tr.find('.rate')).val(rate);
                $(tr.find('.msp')).val(msp);
                $(tr.find('.mrp')).val(mrp);
                $(tr.find('.unit')).val(unit);
            },
            error: function (request, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }



    $('#addnew').click(function () {
        AddRows();
    });

    function autoAddRows() {
        var ctr = $('#items').val();
        var tr = $(this).closest("tr");
        var srno = tr.find(".srno").val();
        if (srno == ctr) {
            AddRows();

        }
    }

    function remove() {
        $(this).closest("tr").remove();
    }

    function AddRows() {
        var ctr = $('#items').val();
        var hide_check = "";
        if ($("#del_all").prop("checked")) {
            hide_check = 0;
        } else {
            hide_check = 1;
        }
        var detail = ".fetchpart_" + ctr;
        $.post('debnote_add.php', {ctr: ctr, hide: hide_check}, function (data) {
            $(data).appendTo('.tbody');
            ctr++;
            $('#items').val(ctr);
            $(detail).select2();
        });
    }


    function itemCal() {
        var discperct = 0;
        var gstpercon = $(".cgstperc").val();
        var ngstpercon = gstpercon*2;
        
        switch (ngstpercon) {
            case 5 :
                discperct = '4.762';
                break;
            case 12 :
                discperct = '10.7143';
                break;
            case 18 :
                discperct = '15.254';
                break;
            case 28 :
                discperct = '21.875';
                break;
        }
//        alert(discperct);
//        $('.discperc').val(discperct);

        var tr = $(this).closest("tr"),
                qty = tr.find(".qty").val(),
                mrp = tr.find(".mrp").val(),
                rate = tr.find(".rate").val(),
                amount = parseFloat(qty) * parseFloat(rate),
                discount = parseFloat(discperct) * parseFloat(amount) / 100,
                total = parseFloat(amount) - parseFloat(discount);

        tr.find(".amount").val(amount);
        tr.find(".discperc").val(discperct);
        tr.find(".discount").val(discount);
        tr.find(".total").val(total);


        var val = 0;
        $(".amount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                val += parseFloat(this.value);
            }
        });
        $(".subtotal").val(val);

        var val2 = 0;
        $(".discount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                val2 += parseFloat(this.value);
            }
        });
        $(".litemdisc").val(val2);
        mainbCal();
    }

    function mainbCal() {

        var subtot = $(".subtotal").val();
        var litemdisc = $(".litemdisc").val();
        var lessoth = $(".lessoth").val();

        var disc1 = subtot - litemdisc;

        var discperc = $(".cdicsperc").val(),
                cdiscamt = (discperc * disc1) / 100;

        if (isNaN(cdiscamt)) {
            $('.cdiscamt').val("0");
        } else {
            $('.cdiscamt').val(cdiscamt.toFixed(2));
        }


        var subtot1 = subtot - litemdisc - cdiscamt - lessoth;

//        var vatperc = $(".vatperc").val(),
//                vatamt = (vatperc * subtot1) / 100;
//
//        if (isNaN(vatamt)) {
//            $('.vatamt').val("0");
//        } else {
//            $('.vatamt').val(vatamt);
//        }


        var pack = $(".packing").val();

        var taxable = parseFloat(subtot1) + parseFloat(pack);

        var cgstperc = parseFloat($(".cgstperc").val());
        var sgstperc = parseFloat($(".sgstperc").val());
        var igstperc = parseFloat($(".igstperc").val());



        var cgstamt = taxable * cgstperc / 100;
        var sgstamt = taxable * sgstperc / 100;
        var igstamt = taxable * igstperc / 100;


        $(".taxamt").val(taxable.toFixed(2));
        $(".igstamt").val(igstamt.toFixed(2));
        $(".cgstamt").val(cgstamt.toFixed(2));
        $(".sgstamt").val(sgstamt.toFixed(2));
//        var pack = $(".packing").val();

        var net = Math.round(parseFloat(taxable) + parseFloat(cgstamt) + parseFloat(sgstamt) + parseFloat(igstamt));

        if (isNaN(net)) {
            $('.netamt').val("0");
        } else {
            $('.netamt').val(net.toFixed(2));
        }



    }


});